Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb.jdbc
Class JDBCResultSetMetaData

    java.lang.Object
      org.hsqldb.jdbc.JDBCResultSetMetaData

All Implemented Interfaces:
  ResultSetMetaData, Wrapper

    public class JDBCResultSetMetaData

extends Object
implements ResultSetMetaData

An object that can be used to get information about the types and properties of the columns in a `ResultSet` object. The following code fragment creates the `ResultSet` object rs, creates the `ResultSetMetaData` object rsmd, and uses rsmd to find out how many columns rs has and whether the first column in rs can be used in a `WHERE` clause.

         ResultSet rs = stmt.executeQuery("SELECT a, b, c FROM TABLE2");
         ResultSetMetaData rsmd = rs.getMetaData();
         int numberOfColumns = rsmd.getColumnCount();
         boolean b = rsmd.isSearchable(1);

### HSQLDB-Specific Information:

HSQLDB supports a subset of the `ResultSetMetaData` interface.

The JDBC specification for `ResultSetMetaData` is in part very vague. This causes potential incompatibility between interpretations of the specification as realized in different JDBC driver implementations. As such, deciding to what degree reporting ResultSetMetaData is accurate has been considered very carefully. Hopefully, the design decisions made in light of these considerations have yeilded precisely the subset of full ResultSetMetaData support that is most commonly needed and that is most important, while also providing, under the most common use-cases, the fastest access with the least overhead and the best comprimise between speed, accuracy, jar-footprint and retention of JDBC resources.

(fredt@users)
(boucherb@users)

Author:
  Campbell Boucher-Burnet (boucherb@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
See Also:
  `JDBCStatement.executeQuery(java.lang.String)`, `JDBCStatement.getResultSet()`, `ResultSetMetaData`

Field Summary

Fields inherited from interface java.sql.ResultSetMetaData
`columnNoNulls, columnNullable, columnNullableUnknown`

Method Summary
`String` | `getCatalogName(int column)` Gets the designated column's table's catalog name.
`String` | `getColumnClassName(int column)`
`int` | `getColumnCount()` Returns the number of columns in this `ResultSet` object.
`int` | `getColumnDisplaySize(int column)` Indicates the designated column's normal maximum width in characters.
`String` | `getColumnLabel(int column)` Gets the designated column's suggested title for use in printouts and displays.
`String` | `getColumnName(int column)` Get the designated column's name.
`int` | `getColumnType(int column)` Retrieves the designated column's SQL type.
`String` | `getColumnTypeName(int column)` Retrieves the designated column's database-specific type name.
`int` | `getPrecision(int column)` (JDBC4 clarification:) Get the designated column's specified column size.
`int` | `getScale(int column)` Gets the designated column's number of digits to right of the decimal point.
`String` | `getSchemaName(int column)` Get the designated column's table's schema.
`String` | `getTableName(int column)` Gets the designated column's table name.
`boolean` | `isAutoIncrement(int column)` Indicates whether the designated column is automatically numbered.
`boolean` | `isCaseSensitive(int column)` Indicates whether a column's case matters.
`boolean` | `isCurrency(int column)` Indicates whether the designated column is a cash value.
`boolean` | `isDefinitelyWritable(int column)` Indicates whether a write on the designated column will definitely succeed.
`int` | `isNullable(int column)` Indicates the nullability of values in the designated column.
`boolean` | `isReadOnly(int column)` Indicates whether the designated column is definitely not writable.
`boolean` | `isSearchable(int column)` Indicates whether the designated column can be used in a where clause.
`boolean` | `isSigned(int column)` Indicates whether values in the designated column are signed numbers.
`boolean` | `isWrapperFor(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`boolean` | `isWritable(int column)` Indicates whether it is possible for a write on the designated column to succeed.
`String` | `toString()` Returns a string representation of the object.
`
`<T> T`
` | `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### getColumnCount

    public int getColumnCount()
                       throws SQLException

  Returns the number of columns in this `ResultSet` object.

  Specified by:
    `getColumnCount` in interface `ResultSetMetaData`
  Returns:
    the number of columns
  Throws:
    `SQLException` - if a database access error occurs

### isAutoIncrement

    public boolean isAutoIncrement(int column)
                            throws SQLException

  Indicates whether the designated column is automatically numbered.

  (JDBC4 deleted:)[, thus read-only.]

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 fully supports SQL Satandard features T174 and T176 that define identity column support.

  However, it must be stated here that contrary to the generic documentation previous to the JDBC4 specification, HSQLDB automatically numbered columns (IDENTITY columns, in HSQLDB parlance) are not read-only.

  In fact, the generic documentation previous to the JDBC4 specification seems to contradict the general definition of what, at minimum, an auto-increment column is:

  Simply, an auto-increment column is one that guarantees it has a autogenerated value after a successful insert or update operation, even if no value is supplied, or DEFAULT is specified.

  Specified by:
    `isAutoIncrement` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### isCaseSensitive

    public boolean isCaseSensitive(int column)
                            throws SQLException

  Indicates whether a column's case matters.

  ### HSQLDB-Specific Information:

  HSQLDB 1.7.1 did not report this value accurately.

  Starting with 1.7.2, this feature is better supported.

  This method returns true for any column whose data type is a character type, with the exception of VARCHAR_IGNORECASE for which it returns false. It also returns false for any column whose data type is a not a character data type.

  Specified by:
    `isCaseSensitive` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### isSearchable

    public boolean isSearchable(int column)
                         throws SQLException

  Indicates whether the designated column can be used in a where clause.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 handles this differently from previous versions.

  If the column in question is a database table or view column, and the type of the column allows searching, then returns true, otherwise false.

  Specified by:
    `isSearchable` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### isCurrency

    public boolean isCurrency(int column)
                       throws SQLException

  Indicates whether the designated column is a cash value.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 fully supports this feature and returns true for NUMERIC and DECIMAL columns.

  Specified by:
    `isCurrency` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### isNullable

    public int isNullable(int column)
                   throws SQLException

  Indicates the nullability of values in the designated column.

  ### HSQLDB-Specific Information:

  HSQLDB 2.2 fully supports this feature.

  `columnNoNulls` is always returned for result set columns that represent constants, sequences or table columns known to be not null. `columnNullable` is returned for NULL constants, or nullable table columns. `columnNullableUnknown` is returned for all other columns such as aggregates and computed values.

  To determine the nullable status of a table column in isolation from ResultSetMetaData and in a DBMS-independent fashion, the DatabaseMetaData.getColumns() method can be invoked with the appropriate filter values and the result should be inspected at the position described in the DatabaseMetaData.getColumns() API documentation.

  Specified by:
    `isNullable` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    the nullability status of the given column; one of `columnNoNulls`, `columnNullable` or `columnNullableUnknown`
  Throws:
    `SQLException` - if a database access error occurs

### isSigned

    public boolean isSigned(int column)
                     throws SQLException

  Indicates whether values in the designated column are signed numbers.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 fully supports this feature.

  Specified by:
    `isSigned` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getColumnDisplaySize

    public int getColumnDisplaySize(int column)
                             throws SQLException

  Indicates the designated column's normal maximum width in characters.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 fully supports this feature.

  The current calculation follows these rules:

  1. Long character types and datetime types:

     The maximum length/precision, repectively.

  2. CHAR and VARCHAR types:

     - If the result set column is a direct pass through of a table column value and column size was declared, then the declared value is returned.

     - Otherwise, the computed length according to SQL Standard is returned. For very large values, the value of the system property hsqldb.max_xxxchar_display_size or the magic value 32766 (0x7FFE) (tested usable/accepted by most tools and compatible with assumptions made by java.io read/write UTF) when the system property is not defined or is not accessible, due to security constraints.

     It must be noted that the latter value in no way affects the ability of the HSQLDB JDBC driver to retrieve longer values and serves only as the current best effort at providing a value that maximizes usability across a wide range of tools, given that the HSQLDB database engine allows very large lengths to be declared.

  3. Number types:

     The max precision, plus the length of the negation character (1), plus (if applicable) the maximum number of characters that may occupy the exponent character sequence. Note that some legacy tools do not correctly handle BIGINT values of greater than 18 digits.

  4. BOOLEAN type:

     The length of the character sequence "false" (5), the longer of the two boolean value String representations.

  5. Remaining types:

     The maximum length/precision, respectively, as reported by DatabaseMetaData.getTypeInfo(), when applicable. If the maximum display size is unknown, unknowable or inapplicable, then zero is returned.

  Specified by:
    `getColumnDisplaySize` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    the normal maximum number of characters allowed as the width of the designated column
  Throws:
    `SQLException` - if a database access error occurs

### getColumnLabel

    public String getColumnLabel(int column)
                          throws SQLException

  Gets the designated column's suggested title for use in printouts and displays. (JDBC4 clarification:) The suggested title is usually specified by the SQL `AS` clause. If a SQL `AS` is not specified, the value returned from `getColumnLabel` will be the same as the value returned by the `getColumnName` method.

  ### HSQLDB-Specific Information:

  In HSQLDB, a `ResultSet` column label is determined using the following order of precedence:

  1. The label (alias) specified in the generating query.
  2. The name of the underlying column, if no label is specified.
     C1, C2, etc. for computed columns that have no label.

  Specified by:
    `getColumnLabel` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    the suggested column title
  Throws:
    `SQLException` - if a database access error occurs

### getColumnName

    public String getColumnName(int column)
                         throws SQLException

  Get the designated column's name.

  ### HSQLDB-Specific Information:

  In HSQLDB, a ResultSet column name is determined using the following order of prcedence:

  1. The name of the underlying columnm, if the ResultSet column represents a column in a table.
  2. The label or alias specified in the generating query.
  C1, C2, etc. for computed columns that have no label.

  If the `jdbc.get_column_name` property of the JDBC Connection has been set to false, this method returns the same value as `getColumnLabel(int)`.

  Specified by:
    `getColumnName` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    column name
  Throws:
    `SQLException` - if a database access error occurs

### getSchemaName

    public String getSchemaName(int column)
                         throws SQLException

  Get the designated column's table's schema.

  ### HSQLDB-Specific Information:

  Since 1.8.0.x, HSQLDB implements standard SQL SCHEMA support; this method returns the actual schema of the column's table. Columns generated in queries have no schema name.

  Specified by:
    `getSchemaName` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    schema name or "" if not applicable
  Throws:
    `SQLException` - if a database access error occurs

### getPrecision

    public int getPrecision(int column)
                     throws SQLException

  (JDBC4 clarification:) Get the designated column's specified column size. For numeric data, this is the maximum precision. For character data, this is the [maximum] length in characters. For datetime datatypes, this is the [maximim] length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the [maximum] length in bytes. For the ROWID datatype, this is the length in bytes[, as returned by the implementation-specific java.sql.RowId.getBytes() method]. 0 is returned for data types where the column size is not applicable.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 reports the correct length or precision for all columns. For DOUBLE, the binary precision of 64 is returned, while for other numeric types the decimal precision is returned.

  Specified by:
    `getPrecision` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    precision
  Throws:
    `SQLException` - if a database access error occurs

### getScale

    public int getScale(int column)
                 throws SQLException

  Gets the designated column's number of digits to right of the decimal point. 0 is returned for data types where the scale is not applicable.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 reports the correct scale for all columns.

  For datetime and interval types such as Timestamp or Time, the fractional second precision is reported.

  The reported scale for INTEGER, BIGINT and DOUBLE is 0

  Specified by:
    `getScale` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    scale
  Throws:
    `SQLException` - if a database access error occurs

### getTableName

    public String getTableName(int column)
                        throws SQLException

  Gets the designated column's table name.

  Specified by:
    `getTableName` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    table name or "" if not applicable
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogName

    public String getCatalogName(int column)
                          throws SQLException

  Gets the designated column's table's catalog name.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB returns the name of the catalog. The default name is PUBLIC. This value can be changed for the database using an SQL command.

  HSQLDB supports use of catalog qualification in DLL or DML when it is allowed by the Standard.

  However, not all clients respect the SQL Standard and may use a catalog qualifier in a context where it is not suppoted by the Standard.

  For greater detail, see discussion at: `JDBCDatabaseMetaData`.

  Specified by:
    `getCatalogName` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    the name of the catalog for the table in which the given column appears or "" if not applicable
  Throws:
    `SQLException` - if a database access error occurs

### getColumnType

    public int getColumnType(int column)
                      throws SQLException

  Retrieves the designated column's SQL type.

  ### HSQLDB-Specific Information:

  This reports the SQL type code of the column. For time and timestamp types that are WITH TIME ZONE, the values as the SQL Standarc CLI codes.

  Specified by:
    `getColumnType` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    SQL type from java.sql.Types
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Types`

### getColumnTypeName

    public String getColumnTypeName(int column)
                             throws SQLException

  Retrieves the designated column's database-specific type name.

  Specified by:
    `getColumnTypeName` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    type name used by the database. If the column type is a user-defined type, then a fully-qualified type name is returned.
  Throws:
    `SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly(int column)
                       throws SQLException

  Indicates whether the designated column is definitely not writable.

  ### HSQLDB-Specific Information:

  From 2.0 this method returns true if the ResuleSet is not updatable or the column in question is not updatable.

  Specified by:
    `isReadOnly` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### isWritable

    public boolean isWritable(int column)
                       throws SQLException

  Indicates whether it is possible for a write on the designated column to succeed.

  ### HSQLDB-Specific Information:

  From 2.0 this method returns false if the ResuleSet is not updatable or the column in question is not updatable.

  Specified by:
    `isWritable` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### isDefinitelyWritable

    public boolean isDefinitelyWritable(int column)
                                 throws SQLException

  Indicates whether a write on the designated column will definitely succeed.

  ### HSQLDB-Specific Information:

  From 2.0 this method returns false if the ResuleSet is not updatable or the column in question is not updatable.

  Specified by:
    `isDefinitelyWritable` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getColumnClassName

    public String getColumnClassName(int column)
                              throws SQLException

  Returns the fully-qualified name of the Java class whose instances are manufactured if the method `ResultSet.getObject` is called to retrieve a value from the column. `ResultSet.getObject` may return a subclass of the class returned by this method.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 fully supports this feature.

  For columns of type OTHER, there is no specific class name and java.lang.Object is returned.

  Specified by:
    `getColumnClassName` in interface `ResultSetMetaData`
  Parameters:
    `column` - the first column is 1, the second is 2, ...
  Returns:
    the fully-qualified name of the class in the Java programming language that would be used by the method `ResultSet.getObject` to retrieve the value in the specified column. This is the class name used for custom mapping.
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCResultSet)

### unwrap

    public <T> T unwrap(Class<T> iface)
             throws SQLException

  Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

  Specified by:
    `unwrap` in interface `Wrapper`
  Parameters:
    `iface` - A Class defining an interface that the result must implement.
  Returns:
    an object that implements the interface. May be a proxy for the actual implementing object.
  Throws:
    `SQLException` - If no object found that implements the interface
  Since:
    JDK 1.6, HSQLDB 1.8.x

### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

  Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

  Specified by:
    `isWrapperFor` in interface `Wrapper`
  Parameters:
    `iface` - a Class defining an interface.
  Returns:
    true if this implements the interface or directly or indirectly wraps an object that does.
  Throws:
    `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
  Since:
    JDK 1.6, HSQLDB 1.8.x

### toString

    public String toString()

  Returns a string representation of the object.

  The string consists of the name of the class of which the object is an instance, the at-sign character ``@`', the unsigned hexadecimal representation of the hash code of the object and a comma-delimited list of this object's indexed attributes, enclosed in square brakets.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 - 2013 HSQL Development Group.